﻿''' <summary>
''' An instance of this exception is thrown if an invalid setup of an ini file is detected.
''' </summary>
Public Class IniFileSyntaxException
    Inherits Exception

    ''' <summary>
    ''' Initializes a new instance of the IniFileSyntaxException class.
    ''' </summary>
    Public Sub New()
        MyBase.New("The syntax of the stream is not valid.")
    End Sub

    ''' <summary>
    ''' Initializes a new instance of the IniFileSyntaxException class using a custom message.
    ''' </summary>
    ''' <param name="message">A description of the occuring exception.</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal message As String)
        MyBase.New(message)
    End Sub

    ''' <summary>
    ''' Initializes a new instance of the IniFileSyntaxException class using a custom message.
    ''' </summary>
    ''' <param name="message">A description of the occuring exception.</param>
    ''' <param name="innerException">The exception which caused this exception to be thrown.</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal message As String, ByVal innerException As Exception)
        MyBase.New(message, innerException)
    End Sub
End Class
